#region using
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Globalization;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Design;
using System.ServiceModel.Security.Protocols;
using System.Text;
using System.Xml;
#endregion
namespace Microsoft.ServiceModel.Samples.Transport
{
    public class TcpBindingElement : BindingElement, ITransportBindingElement
    {
        #region ctors
        public TcpBindingElement()
        {
        }

        TcpBindingElement(TcpBindingElement other)
            : base(other)
        {
        }
        #endregion

        #region Build Methods
        public override bool CanBuildChannelListener<TChannel>(ChannelBuildContext context)
        {
            if (typeof(TChannel) == typeof(IDuplexSessionChannel))
                return true;

            return false;
        }

        public override IChannelListener<TChannel> BuildChannelListener<TChannel>(ChannelBuildContext context)
        {
            IMessageEncodingBindingElement encodingBindingElement =
                context.UnhandledBindingElements.Remove<IMessageEncodingBindingElement>();

            return (IChannelListener<TChannel>)(object)new TcpChannelListener(encodingBindingElement);
        }

        public override IChannelFactory BuildChannelFactory(ChannelBuildContext context)
        {
            IMessageEncodingBindingElement encodingBindingElement =
                context.UnhandledBindingElements.Remove<IMessageEncodingBindingElement>();

            return new TcpChannelFactory(encodingBindingElement);
        }
        #endregion

        #region BindingElement Infrastructure Overrides
        public override BindingElement Clone()
        {
            return new TcpBindingElement(this);
        }

        public override ChannelProtectionRequirements GetProtectionRequirements()
        {
            return null;
        }
        #endregion

        #region ITransportBindingElement members
        string ITransportBindingElement.Scheme
        {
            get
            {
               // change this to soap.tcp for WSE 3.0 interop
                return "my.tcp";
            }
        }
        #endregion
    }
}