using System;
using System.ServiceModel;
using Microsoft.ServiceModel.Samples.Transport;

namespace TcpTestService
{
    class TcpService
    {
        static void Main(string[] args)
        {
            Uri uri = new Uri("my.tcp://localhost:9000/a/b/");
            TcpChannelListener listener = new TcpChannelListener(
                new BinaryMessageEncodingBindingElement());
            listener.SetUri(uri);
            listener.Open();
            Console.WriteLine("Service started at " + uri);
            Console.WriteLine();

            IDuplexSessionChannel channel = listener.AcceptChannel(
               TimeSpan.MaxValue);
            channel.Open();
            Message message;
            while ((message = channel.Receive(TimeSpan.MaxValue)) != null)
            {
                string action = message.Headers.Action;
                string body = message.GetBody<string>();
                Console.WriteLine(
                   string.Format("Received Action: {0}, Body {1}",
                    action, body));
                Console.WriteLine();

                if (action == "http://SayHello")
                {
                    Message helloMessage = Message.CreateMessage("http://Hello", "Hello " + body);
                    channel.Send(helloMessage);
                }
                message.Close();
            }
            channel.Close();
            Console.ReadLine();
        }
    }
}
