using System;
using System.ServiceModel;
using Microsoft.ServiceModel.Samples.Transport;

namespace TestTcpClient
{
   class TcpClient
   {
      static void Main(string[] args)
      {
         TcpChannelFactory channelFactory = new TcpChannelFactory(
             new BinaryMessageEncodingBindingElement());

         channelFactory.Open();
         using (channelFactory)
         {
            Uri uri = new Uri("my.tcp://localhost:9000/a/b/");
            IDuplexSessionChannel channel = 
               channelFactory.CreateChannel<IDuplexSessionChannel>(uri);

            Console.Write("Say Hello to: ");
            string name = Console.ReadLine();
            Message requestMessage =
               Message.CreateMessage("http://SayHello", name);
            channel.Open();
            channel.Send(requestMessage);
            Message hello = channel.Receive();
            using (hello)
            {
               Console.WriteLine(hello.GetBody<string>());
            }
            Console.WriteLine();

            Console.Write("Say NotHello to: ");
            name = Console.ReadLine();
            requestMessage = Message.CreateMessage("http://NotHello", name);
            channel.Send(requestMessage);
            channel.Close();
         }
         Console.ReadLine();
      }
   }
}
