#region using
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Media;
using System.Windows.Shapes;
using System.ServiceModel;
using Microsoft.ServiceModel.Samples.Transport;
#endregion
namespace Stocks
{
   public partial class Window1 : Window
   {
      #region ctor
      public Window1()
      {
         InitializeComponent();
      }
      #endregion

      void LookUpSymbols(object sender, RoutedEventArgs e)
      {
         // WSE 3.0 uses MTOM as the payload of their TCP channels,
         // so we create a custom binding with MTOM+our TCP channel
         CustomBinding binding = new CustomBinding();
         binding.Elements.Add(new MtomMessageEncodingBindingElement());
         binding.Elements.Add(new TcpBindingElement());

         // get the address from user input
         EndpointAddress address =
             new EndpointAddress(addressTextBox.Text);

         // create the Indigo proxy to the WSE service
         WseProxy proxy =
             new WseProxy(address, binding);

         // make the request based on user input
         string symbolsText = textBox.Text;
         string[] symbols = symbolsText.Split(' ');
         StockQuote[] quotes = proxy.StockQuoteRequest(symbols);

         // TODO: use data binding in the XAML to bind to the StockQuote results
         #region display results
         foreach (StockQuote quote in quotes)
         {
            resultsTextBlock.Inlines.Add("Symbol: " + quote.Symbol);
            resultsTextBlock.Inlines.Add(new LineBreak());
            resultsTextBlock.Inlines.Add("Name: " + quote.Name);
            resultsTextBlock.Inlines.Add(new LineBreak());
            resultsTextBlock.Inlines.Add("Last Price: " + quote.Last);
            resultsTextBlock.Inlines.Add(new LineBreak());
            resultsTextBlock.Inlines.Add(new LineBreak());
         }
         #endregion
      }
   }
}